#!/usr/bin/env python3

import networkx as nx
import csv
import matplotlib.pyplot as plt

G = nx.DiGraph()

with open("edgelist_1.csv") as f:
    reader = csv.reader(f, delimiter = " ", skipinitialspace = True)

    # Skip title lines:
    next(reader) 
    next(reader)
    
    for row in reader:
        k1, i1, k2, i2, weight = int(row[0]), int(row[1]), int(row[2]), \
                                 int(row[3]), float(row[4])
        G.add_edge((k1, i1), (k2, i2), weight = weight)

pos = nx.nx_agraph.graphviz_layout(G, prog="dot")

plt.figure()
nx.draw(G, pos, with_labels=True)
plt.show()
