program test_read_eddy

  ! Libraries:
  use shapelib, only: shpfileobject, shpclose
  use shapelib_03, only: shp_open_03

  use derived_types, only: eddy
  use init_shapefiles_m, only: init_shapefiles
  use read_eddy_m, only: read_eddy
  use read_field_indices_m, only: read_field_indices
  use write_eddy_m, only: write_eddy

  implicit none

  type(eddy) e
  integer k, i
  TYPE(shpfileobject) hshp_extremum ! shapefile extremum_1
  TYPE(shpfileobject) hshp_outermost ! shapefile outermost_contour_1
  TYPE(shpfileobject) hshp_max_speed ! shapefile max_speed_contour_1

  !-------------------------------------------------------------------------

  call shp_open_03("extremum_1_old", pszaccess = "rb", hshp = hshp_extremum)
  call shp_open_03("outermost_contour_1_old", pszaccess = "rb", &
       hshp = hshp_outermost)
  call shp_open_03("max_speed_contour_1_old", pszaccess = "rb", &
       hshp = hshp_max_speed)
  call read_field_indices(hshp_extremum, hshp_outermost, hshp_max_speed)
  call read_eddy(e, k, i, hshp_extremum, hshp_outermost, hshp_max_speed, &
       ishape = 0)
  CALL shpclose(hshp_extremum)
  CALL shpclose(hshp_outermost)
  CALL shpclose(hshp_max_speed)

  call init_shapefiles(hshp_extremum, hshp_outermost, hshp_max_speed)
  call write_eddy(e, k, i, hshp_extremum, hshp_outermost, hshp_max_speed)
  CALL shpclose(hshp_extremum)
  print *, 'Created shapefile "extremum_1".'
  CALL shpclose(hshp_outermost)
  print *, 'Created shapefile "outermost_contour_1".'
  CALL shpclose(hshp_max_speed)
  print *, 'Created shapefile "max_speed_contour_1".'

end program test_read_eddy
