program test_successive_overlap

  use, intrinsic:: ISO_FORTRAN_ENV

  ! Libraries:
  use jumble, only: new_unit
  use nr_util, only: deg_to_rad
  use shapelib, only: shpfileobject, shpclose
  use shapelib_03, only: shp_open_03

  use derived_types, only: snapshot
  use read_snapshot_m, only: read_snapshot
  use successive_overlap_m, only: successive_overlap

  implicit none

  integer unit_edgelist, i
  type(snapshot) flow(2)
  TYPE(shpfileobject) hshp_extremum ! shapefile extremum_1
  TYPE(shpfileobject) hshp_outermost ! shapefile outermost_contour_1
  TYPE(shpfileobject) hshp_max_speed ! shapefile max_speed_contour_1

  real:: corner(2) = [huge(0.), huge(0.)]
  ! longitude and latitude of the corner of the whole grid, in degrees

  integer:: nlon = - 1, nlat = - 1
  namelist /main_nml/ corner, nlon, nlat

  !-------------------------------------------------------------------------

  write(unit = error_unit, nml = main_nml)
  write(unit = error_unit, fmt = *) "Enter namelist main_nml."
  read(unit = *, nml = main_nml)
  write(unit = *, nml = main_nml)

  call shp_open_03("extremum_1", pszaccess = "rb", hshp = hshp_extremum)
  call shp_open_03("outermost_contour_1", pszaccess = "rb", &
       hshp = hshp_outermost)
  call shp_open_03("max_speed_contour_1", pszaccess = "rb", &
       hshp = hshp_max_speed)
  call read_snapshot(flow(1), hshp_extremum, hshp_outermost, hshp_max_speed, &
       corner * deg_to_rad, nlon, nlat)
  CALL shpclose(hshp_extremum)
  CALL shpclose(hshp_outermost)
  CALL shpclose(hshp_max_speed)

  flow(2) = flow(1)
  call new_unit(unit_edgelist)
  open(unit_edgelist, file = "edgelist_1.csv", status = "replace", &
       action  = "write")

  ! Title lines:
  write(unit_edgelist, fmt = "(1x, a)") '"predecessor date index" ' &
       // '"predecessor eddy index" "successor date index" ' &
       // '"successor eddy index"'
  write(unit_edgelist, fmt = *) "k1 i1 k2 i2 weight"
  
  call successive_overlap(unit_edgelist, nlon, nlat, flow, j = 2, k = 2)
  close(unit_edgelist)
  print *, 'Created file "edgelist_1.csv".'

  do i = 1, 2
     print *, "flow(", i, ")%list_vis%delta_in:", flow(i)%list_vis%delta_in
     print *, "flow(", i, ")%list_vis%delta_out:", flow(i)%list_vis%delta_out
  end do

end program test_successive_overlap
