module dispatch_snapshot_m

  implicit none

contains

  subroutine dispatch_snapshot(s, hshp_extremum, hshp_outermost, &
       hshp_max_speed, unit_isolated, unit_number_eddies, k, m, k_begin, &
       max_delta)

    use derived_types, only: snapshot
    use send_snapshot_m, only: send_snapshot
    use shapelib, only: shpfileobject
    use write_eddy_m, only: write_eddy

    type(snapshot), intent(in):: s

    TYPE(shpfileobject), intent(inout):: hshp_extremum ! shapefile extremum_$m

    TYPE(shpfileobject), intent(inout):: hshp_outermost
    ! shapefile outermost_contour_$m

    TYPE(shpfileobject), intent(inout):: hshp_max_speed
    ! shapefile x_speed_contour_$m

    integer, intent(in):: unit_isolated
    ! logical unit for file isolated_nodes_$m.csv

    integer, intent(in):: unit_number_eddies
    ! logical unit for file number_eddies_$m.csv

    integer, intent(in):: k ! date index
    integer, intent(in):: m, k_begin, max_delta

    ! Local:
    integer i

    !------------------------------------------------------------------

    if (m == 1 .or. k >= k_begin + max_delta) then
       ! Write snapshot:

       do i = 1, s%number_vis_eddies
          call write_eddy(s%list_vis(i), k, i, hshp_extremum, hshp_outermost, &
               hshp_max_speed)
          if (s%list_vis(i)%delta_in == huge(0) .and. s%list_vis(i)%delta_out &
               == huge(0)) write(unit_isolated, fmt = *) k, i
       end do

       write(unit_number_eddies, fmt = *) k, s%number_vis_eddies, &
            s%number_eddies - s%number_vis_eddies
    else
       call send_snapshot(s, tag = k, dest = m - 1)
    end if

  end subroutine dispatch_snapshot

end module dispatch_snapshot_m
